/**
 * Program       : SortAlgorithm.java
 * Date          : May 7, 2001
 * Author        : Taufik Fuadi Abidin, Mahyus Ihsan
 * Acknowledgment: Original source written by
 *                 James Gosling from Sun Microsystems, Inc.
 *                 1997
 */

public class SortAlgorithm
{
  private SortItem parent;
  protected boolean stopRequested = false;
  protected int nswap, ncomparison;

  public void setParent(SortItem p)
  {
    parent = p;
  }

  protected void pause(int H1, int H2) throws Exception
  {
    if (stopRequested)
    {
      throw new Exception("Sort Algorithm");
    }
    parent.pause(H1, H2);
  }

  public void stop()
  {
    stopRequested = true;
  }

  public void init()
  {
    nswap = 0;
    ncomparison = 0;
    stopRequested = false;
  }

  public int getNumOfSwap()
  {
    return nswap;
  }

  public int getNumOfCompare()
  {
    return ncomparison;
  }

  public void sort(int item[]) throws Exception
  {
    /* Implemented in subclasses */
  }
}
